/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The name "Exolab" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of Intalio Inc.  For written permission, please
 *    contact info@exolab.org.
 *
 * 4. Products derived from this Software may not be called "Exolab"
 *    nor may "Exolab" appear in their names without prior written
 *    permission of Intalio Inc. Exolab is a registered trademark of
 *    Intalio Inc.
 *
 * 5. Due credit should be given to the Exolab Project
 *    (http://www.exolab.org/).
 *
 * THIS SOFTWARE IS PROVIDED BY INTALIO AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL INTALIO OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2000 (C) Intalio Inc. All Rights Reserved.
 *
 * $Id: AbstractClientRequest.java,v 1.3 2001/03/07 08:07:19 wood Exp $
 *
 * Date         Author  Changes
 */

/** Modified/extended by Diana Szentivanyi in June 2003
* contact diasz@ida.liu.se
*/

package org.openorb.net;

import java.util.Map;
import java.util.HashMap;

/**
 * Base class which implements some of the ClientRequest functionality.
 *
 * @author <a href="mailto:wood@intalio.com">Chris Wood &lt;wood@intalio.com&gt;</a>
 * @version $Revision: 1.3 $ $Date: 2001/03/07 08:07:19 $
 */
public abstract class AbstractClientRequest
  extends org.omg.CORBA.LocalObject
  implements ClientRequest
{

  /** Creates new AbstractClientRequest */
  public AbstractClientRequest(int request_id, org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
		_transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();

    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
    piCurrEntry = piCurrent.copy(piCurrent.get());
    result=orb.create_any();
  }


    /* new constructor introduced by Diana on 27 Aug. 2001*/
      public AbstractClientRequest(int request_id,int retention_id,String client_id, org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
    this.retention_id=retention_id;
    this.client_id=client_id;
    _transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();
    result=orb.create_any();
    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
		piCurrEntry = piCurrent.copy(piCurrent.get());
      }

    /* Mod. by Diana on Oct. 28 2001*/

    public AbstractClientRequest(int request_id,int retention_id,String client_id, long request_start_time,org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
    this.retention_id=retention_id;
    this.client_id=client_id;
    this.request_start_time=request_start_time;
    _transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();
    result=orb.create_any();
    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
		piCurrEntry = piCurrent.copy(piCurrent.get());
      }

      public AbstractClientRequest(int request_id,int retention_id,String client_id, org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
    this.retention_id=retention_id;
    this.client_id=client_id;
    this.arguments=arguments;
    _transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();
    result=orb.create_any();
    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
		piCurrEntry = piCurrent.copy(piCurrent.get());
      }

     public AbstractClientRequest(int request_id,int retention_id,String client_id, org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
    this.retention_id=retention_id;
    this.client_id=client_id;
    this.arguments=arguments;
    this.exceptions=exceptions;
    this.result=result;
    _transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();

    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
		piCurrEntry = piCurrent.copy(piCurrent.get());
      }


      public AbstractClientRequest(int request_id,int retention_id,String client_id, long request_start_time,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target,
	                             Address address, Object transportAssociation,
															 ClientChannel channel) {
    this.address = address;
    this.channel = channel;
    this.target = target;
    this.request_id = request_id;
    this.retention_id=retention_id;
    this.client_id=client_id;
    this.request_start_time=request_start_time;
    this.arguments=arguments;
    this.exceptions=exceptions;
    this.result=result;
    _transportAssociation = transportAssociation;

    target_deleg = (org.openorb.CORBA.Delegate)((org.omg.CORBA.portable.ObjectImpl)target)._get_delegate();

    target_ior = target_deleg.ior();

    orb = ((org.omg.CORBA.portable.ObjectImpl)target)._orb();

    piCurrent = ((org.openorb.CORBA.ORB)orb).getPICurrent();
		piCurrEntry = piCurrent.copy(piCurrent.get());
      }

    private org.omg.CORBA.ORB orb;

  private org.omg.CORBA.Object target;
  private org.openorb.CORBA.Delegate target_deleg;
  private org.omg.IOP.IOR target_ior;

  private org.omg.CORBA.Object effective_target;
  private org.omg.IOP.IOR effective_target_ior;

	private Object _transportAssociation;

  private ClientChannel channel;
  private Address address;

  private org.openorb.PI.CurrentImpl piCurrent;
  private org.omg.PortableInterceptor.CurrentOperations piCurrEntry;

  private org.openorb.policy.PolicyReconciler orb_reconciler = null;

  private Map service_contexts = new HashMap();

    private int request_id;


    private int retention_id=-1; /* field introduced by Diana on Aug. 27 2001*/
    private String client_id="";
    private long request_start_time=0;
    private org.omg.Dynamic.Parameter[] arguments=new org.omg.Dynamic.Parameter[0];
    private org.omg.CORBA.TypeCode[] exceptions=new org.omg.CORBA.TypeCode[0];
    private org.omg.CORBA.Any result;

  /**
   * Client channel
   */
  public ClientChannel channel() {
    return channel;
  }

  /**
   * Client address
   */
  public Address address() {
    return address;
  }

  /**
   * Request ID.
   */
  public int request_id() {
    return request_id;
  }

    public int retention_id(){
	return retention_id;
    }

    public String client_id(){
	return client_id;
    }

    public long request_start_time(){
	return request_start_time;
    }


    public void retention_id(int retention_id){
	this.retention_id=retention_id;
    }

     public org.omg.Dynamic.Parameter[] arguments(){
	return arguments;
    }

    public org.omg.CORBA.TypeCode[] exceptions(){
	return exceptions;
    }


    public org.omg.CORBA.Any result(){
	return result;
    }
  /**
   * Equality depends on request IDs
   */
  public boolean equals(Object obj) {
    if(obj instanceof Integer)
      return request_id == ((Integer)obj).intValue();
    if(obj instanceof ClientRequest)
      return request_id == ((ClientRequest)obj).request_id();
    return false;
  }

  /**
   * Get the target IOR. This ior is the marshalling ior of the object passed
   * at creation time.
   */
  public org.omg.IOP.IOR target_ior() {
    return target_ior;
  }

  /**
   * Object the request was created with.
   */
  public org.omg.CORBA.Object target() {
    return target;
  }

  /**
   * ORB associated with the target.
   */
  public org.omg.CORBA.ORB orb() {
    return orb;
  }

  /**
   * Get the effective target IOR. This gets the IOR from the address passed
   * in creation. Calling this function instead of effective_target avoids
   * constructing an enclosing delegate/object.
   */
  public org.omg.IOP.IOR effective_target_ior() {
    if(effective_target_ior == null)
      effective_target_ior = address.getTargetAddress(org.omg.GIOP.ReferenceAddr.value).ior().ior;
    return effective_target_ior;
  }

  /**
   * Return the effective_target object. This is the destination for this request.
   */
  public org.omg.CORBA.Object effective_target() {
    if(effective_target == null)
      effective_target = new org.openorb.CORBA.ObjectStub(orb, effective_target_ior());
    return effective_target;
  }

	/**
	 * Get the transport association.
	 */
	public Object get_transport_association() {
		return _transportAssociation;
	}

	/**
	 * Check the transport association, take appropriate action if association
	 * is incorrect. This will be called once for each reply and reply fragment.
	 */
	public boolean checkReplyTransportAssoc(Object tpAssc) {
		// TODO: make this controlable by policy.
		return _transportAssociation.equals(tpAssc);
	}

	/**
   * Profile as used in this request.
   */
  public org.omg.IOP.TaggedProfile effective_profile() {
    return address.getTargetAddress(org.omg.GIOP.ProfileAddr.value).profile();
  }

  public org.omg.IOP.TaggedComponent get_effective_component(int id) {
    return (get_effective_components(id))[0];
  }

  public org.omg.IOP.TaggedComponent[] get_effective_components(int id) {
    org.omg.IOP.TaggedComponent[] ret = address.get_components(id);
    if(ret == null || ret.length == 0)
      throw new org.omg.CORBA.BAD_PARAM(org.omg.CORBA.OMGVMCID.value | 25, state_completion_status());
    return ret;
  }

  public org.omg.CORBA.Policy get_request_policy(int type) {
    org.omg.CORBA.Policy client_policy = null;
    try {
      client_policy = target_deleg.get_client_policy(target, type);
    }
    catch(org.omg.CORBA.INV_POLICY ex) {}

    org.omg.CORBA.Policy target_policy = null;
    {
      int [] types = new int[1];
      types[0] = type;
      org.omg.CORBA.Policy [] target_pols = address.get_target_policies(types);
      if(target_pols.length > 0)
        target_policy = target_pols[0];
    }

    if(client_policy == null && target_policy == null)
      throw new org.omg.CORBA.INV_POLICY("Policy type not found", org.omg.CORBA.OMGVMCID.value | 1, state_completion_status());

    if(orb_reconciler == null) {
      orb_reconciler = (org.openorb.policy.PolicyReconciler)((org.openorb.CORBA.ORB)orb).getFeature("PolicyReconciler");
      if(orb_reconciler == null)
        throw new org.omg.CORBA.INTERNAL();
    }

    return orb_reconciler.reconcile_policies(type, client_policy, target_policy, null);
  }

  /*  public org.omg.Dynamic.Parameter[] arguments() {
    throw new org.omg.CORBA.NO_RESOURCES(org.omg.CORBA.OMGVMCID.value | 1, state_completion_status());
    }
*/

  public java.lang.String[] contexts() {
    throw new org.omg.CORBA.NO_RESOURCES(org.omg.CORBA.OMGVMCID.value | 1, state_completion_status());
  }

  public java.lang.String[] operation_context() {
    throw new org.omg.CORBA.NO_RESOURCES(org.omg.CORBA.OMGVMCID.value | 1, state_completion_status());
  }

  public org.omg.CORBA.Any get_slot(int id)
    throws org.omg.PortableInterceptor.InvalidSlot
  {
    if(piCurrEntry == null) {
      synchronized(service_contexts) {
        if(piCurrEntry == null)
          piCurrEntry = piCurrent.create();
      }
    }
    return piCurrEntry.get_slot(id);
  }

  public void add_request_service_context(org.omg.IOP.ServiceContext service_context,boolean replace)
  {
    if(state() != STATE_CREATED)
      throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());

    Integer key = new Integer(service_context.context_id);
    synchronized(service_contexts) {
      if(!replace && service_contexts.containsKey(key))
        throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 11, state_completion_status());

      service_contexts.put(key, service_context);
    }
  }

  public org.omg.IOP.ServiceContext get_request_service_context(int id)
  {
    org.omg.IOP.ServiceContext ret = null;
    synchronized(service_contexts) {
      ret = (org.omg.IOP.ServiceContext)service_contexts.get(new Integer(id));
    }
    if(ret == null)
      throw new org.omg.CORBA.BAD_PARAM(org.omg.CORBA.OMGVMCID.value | 23, state_completion_status());
    return ret;
  }

  /**
   * Get all request service contexts that have been set. From MARSHAL onward
   * this will be a constant list.
   */
  public org.omg.IOP.ServiceContext [] get_request_service_contexts() {
    synchronized(service_contexts) {
      return (org.omg.IOP.ServiceContext[])service_contexts.values().toArray(new org.omg.IOP.ServiceContext[service_contexts.size()]);
    }
  }

  /**
   * This utility function returns the correct completion status to use
   * in a system exception depending on the current state.
   */
  public org.omg.CORBA.CompletionStatus state_completion_status() {
    switch(state()) {
    case STATE_CREATED:
    case STATE_MARSHAL:
      return org.omg.CORBA.CompletionStatus.COMPLETED_NO;
    case STATE_WAITING:
      return org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE;
    case STATE_UNMARSHAL:
      return org.omg.CORBA.CompletionStatus.COMPLETED_YES;
    case STATE_COMPLETE:
      switch(reply_status()) {
      case OBJECT_HERE:
      case UNKNOWN_OBJECT:
      case org.omg.PortableInterceptor.SUCCESSFUL.value:
      case org.omg.PortableInterceptor.USER_EXCEPTION.value:
        return org.omg.CORBA.CompletionStatus.COMPLETED_YES;
      case org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value:
        return received_system_exception().completed;
      case org.omg.PortableInterceptor.LOCATION_FORWARD.value:
      case org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:
      case org.omg.PortableInterceptor.TRANSPORT_RETRY.value:
        return org.omg.CORBA.CompletionStatus.COMPLETED_NO;
      }
    }
    throw new Error("assert failed");
  }
}
